﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Loosely based on REFERENCE (2)
Sub Class_Globals

	Public ABM As ABMaterial
	Public ABMComp As ABMCustomComponent

	Private Video_Width As String
	Private Video_Height As String 
	
	Private Parent_Page As ABMPage
	Private Parent_Instance_Name As String

	Public BorderColor As String
	Public BorderIntensity As String
	Public BorderStyle As String
	Public BorderWidth As String
	Public BorderRadius As String
	Public PaddingBottom As String
	Public PaddingLeft As String
	Public PaddingRight As String
	Public PaddingTop As String
	Public ZDepth As String
	
End Sub

Public Sub Initialize(Passed_Page As ABMPage, Passed_Instance_Name As String)
	
	Parent_Page = Passed_Page
	
	Parent_Instance_Name = Passed_Instance_Name.ToLowerCase

	Video_Width = "100%"
	Video_Height = "100%" 'or "auto"
	
	'Set property defaults
	BorderColor = ABM.COLOR_LIGHTBLUE
	BorderIntensity = ABM.INTENSITY_NORMAL
	BorderStyle = ABM.BORDER_NONE
	BorderWidth = "0px"
	BorderRadius = "0px"
	PaddingBottom = "0px"
	PaddingLeft = "0px"
	PaddingRight = "0px"
	PaddingTop = "0px"
	ZDepth = ABM.ZDEPTH_REMOVE

	ABMComp.Initialize("ABMComp", Me, Parent_Page, Parent_Instance_Name, "")
	
End Sub

Sub ABMComp_Build(Passed_page As ABMPage, Passed_Instance_Name As String) As String
	
	'Passed_page is just Parent_page
	'Passed_Instance_Name is just Parent_Instance_Name

	Private cam_div_css As String

	If PaddingTop <> "" Then cam_div_css = cam_div_css & "padding-top: " & PaddingTop & ";"
	If PaddingBottom <> "" Then cam_div_css = cam_div_css & "padding-bottom: " & PaddingBottom & ";"
	If PaddingLeft <> "" Then cam_div_css = cam_div_css & "padding-left: " & PaddingLeft & ";"
	If PaddingRight <> "" Then cam_div_css = cam_div_css & "padding-right: " & PaddingRight & ";"
	If ZDepth <> "" Then cam_div_css = cam_div_css & ZDepth & ";"
	cam_div_css = cam_div_css & "width:" & Video_Width & ";height:" & Video_Height & _
	              ";background:#ffffff;border-radius:0px;"
	
	Private video_css As String

	video_css = "display: none;border-style:" & BorderStyle & ";border-color:" & BorderColor & _
	            ";border-width:" & BorderWidth & ";border-radius:" & BorderRadius & ";" & _
			    "width:" & Video_Width & ";height:" & Video_Height & ";"

	'Note trick employed in Main.AppStart that allows 
	'<audio id="cam_click" src="../camerabits/cameraclick.mp3"></audio>
	'<img src="../camerabits/camerarotate.png"></img>
	'to work

	Private div_str As String

	'Note: if 'autoplay muted playsinline' is not included it will not
	'work on iOS Safari
	div_str = $"
<div id="cam_div" style="${cam_div_css}">
    <video id="cam_video" autoplay muted playsinline style="${video_css}"></video>
    <canvas id="cam_canvas" width=1, height=1 style="display:none;"></canvas>
    <audio id="cam_click" src="../camerabits/cameraclick.mp3"></audio>
    <style>
        #cam_message {
            position: absolute;
            top: 10vh;
            left: 0;
            width: 100%;
            height: 100%;
            display: flex;
            align-items: center;
            justify-content: center;
            background-color: rgba(0, 0, 0, 0.0);
            color: red;
            font-size: min(calc(0rem + 5vw), calc(0rem + 5vh)); /* Adjust scaling as needed -
                                                                   1rem is base font size (which is
                                                                   typically equivalent to 16px), 
                                                                   5vw means 5% of viewport width
                                                                   5vh means 5% of viewport height) */
            text-align: center;
            font-weight: bold;
            padding-top: calc(${PaddingTop} + 10vh);
            padding-right: calc(${PaddingRight} + 10vw);
            padding-bottom: calc(${PaddingBottom} + 10vh);
            padding-left: calc(${PaddingLeft} + 10vw);
        }
        #cam_overlay {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            align-items: center;
            justify-content: center;
            background-color: rgba(0, 0, 0, 0.0);
            color: black;
            font-size: min(calc(0rem + 8vw), calc(0rem + 8vh));
            text-align: center;
            padding-top: calc(${PaddingTop} + 10vh);
            padding-right: calc(${PaddingRight} + 10vw);
            padding-bottom: calc(${PaddingBottom} + 10vh);
            padding-left: calc(${PaddingLeft} + 10vw);
            display: none;
        }
        #cam_toggle {
            position: absolute;
            top: calc(0px + 0px/2 + max(1vh, 1vw));
            left: 50%;
            transform: translateX(-50%);
            background-color: rgba(0, 0, 0, 0.0);
            border: none;
            cursor: pointer;
            display: none;
        }
        #cam_toggle img {
            width: min(calc(0rem + 12vw), calc(0rem + 12vh)); 
            height: calc(width * 448/512);
        }
    </style>
    <div id="cam_message"></div>
    <div id="cam_overlay">
        Tap anywhere here to take a photo
    </div>
    <div>
        <button id="cam_toggle">
            <img src="../camerabits/camerarotate.png"></img>
        </button>
    </div>
</div>
"$

'	Log("<<<<<<<< ABMComp_Build " & div_str)
    
    Return div_str
    
End Sub

Sub ABMComp_FirstRun(Passed_page As ABMPage, Passed_Instance_Name As String)
    
    'Passed_page is just Parent_page
    'Passed_Instance_Name is just Parent_Instance_Name
    
End Sub

Sub ABMComp_Refresh(Passed_page As ABMPage, Passed_Instance_Name As String)
    
    'Passed_page is just Parent_page
    'Passed_Instance_Name is just Parent_Instance_Name

    Private script_str As String = $"
var cam_video = document.getElementById('cam_video');
var cam_overlay = document.getElementById('cam_overlay');
var cam_toggle = document.getElementById('cam_toggle');
var cam_message = document.getElementById('cam_message');
var cam_toggle_display = 'flex'
var constraints = 
{
    audio: false,
    video: 
    {
        //Set camera inital value
        facingMode: 'user'
        //facingMode: 'environment'
    }
}
//
//This does not work in iOS Safari = videoDevices.length always comes back as 1
//on tested iPhones when it should be more
//
//navigator.mediaDevices.enumerateDevices()
//.then(function(devices) 
//{
//    var videoDevices = devices.filter(device => device.kind === 'videoinput');
//    if (videoDevices.length > 1) {
//        cam_toggle_display = 'flex';
//    } else 
//    {
//        cam_toggle_display = 'none';
//   }
//}),
navigator.mediaDevices.getUserMedia(constraints)
.then(function (stream)
{
    cam_video.srcObject=stream;
    cam_video.play();
    cam_video.style.display = 'flex';
    cam_overlay.style.display = 'flex';
    cam_toggle.style.display = cam_toggle_display;
    //cam_message.textContent = 'mediaDevices API supported';
    //b4j_raiseEvent('${Passed_Instance_Name}_Ready', {'value': 'mediaDevices API supported'});
    cam_overlay.addEventListener('click', function() 
    {
        var cam_click = document.getElementById('cam_click');
        cam_click.play();
        var cam_canvas = document.getElementById('cam_canvas');
        var cam_context = cam_canvas.getContext('2d');
        cam_canvas.width = cam_video.videoWidth;
        cam_canvas.height = cam_video.videoHeight;
        cam_context.drawImage(cam_video, 0, 0, cam_video.videoWidth, cam_video.videoHeight);
        var cam_dataURL = cam_canvas.toDataURL('image/jpeg');
        b4j_raiseEvent('${Parent_Instance_Name}_PictureTaken', {'value': cam_dataURL});
    });
    cam_toggle.addEventListener('click', function() 
    {
        cam_toggle.style.display = 'none';
        cam_overlay.style.display = 'none';
        cam_video.style.display = 'none';
        if (constraints.video.facingMode == 'user') 
        {
            constraints.video.facingMode = 'environment';
            //cam_message.textContent = 'video.facingMode environment';
            //b4j_raiseEvent('${Passed_Instance_Name}_Error', {'value': 'environment'});
        } else 
        {
            constraints.video.facingMode = 'user';
            //cam_message.textContent = 'video.facingMode user';
            //b4j_raiseEvent('${Passed_Instance_Name}_Error', {'value': 'user'});
        }
        //Reinitialize camera stream with updated constraints
        if (stream)
        {
            stream.getTracks().forEach(track => track.stop());
            cam_video.pause();
            cam_video.srcObject = null;
        }
        navigator.mediaDevices.getUserMedia(constraints)
        .then(function(stream) 
        {
            cam_video.srcObject = stream;
            cam_video.play();
            cam_video.style.display = 'flex';
            cam_overlay.style.display = 'flex';
            cam_toggle.style.display = cam_toggle_display;
        })
        .catch(function(error) 
        {
            b4j_raiseEvent('${Passed_Instance_Name}_ChromeBug', {'value': error.message});
        })
    });
},
function(error)
{
    cam_toggle.style.display = 'none';
    cam_overlay.style.display = 'none';
    cam_video.style.display = 'none';
    cam_message.textContent = "Your device does not have a camera or your device's camera is in use by another application or your browser does not support mediaDevices API - suggest you use another device or browser.";
    //b4j_raiseEvent('${Passed_Instance_Name}_Error', {'value':"Your device does not have a camera or your device's camera is in use by another application or your browser does not support mediaDevices API - suggest you use another device or browser."});
});    
"$    

'   Log("<<<<<<<< ABMComp_Refresh " & script_str)
    
	Parent_Page.ws.Eval(script_str, Array As Object(Passed_Instance_Name))
	
End Sub

Sub ABMComp_CleanUp(Passed_page As ABMPage, Passed_Instance_Name As String)
	
	'Passed_page is just Parent_page
	'Passed_Instance_Name is just Parent_Instance_Name
	
End Sub
